﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using School.Hero.Api.Models.Context;

namespace School.Hero.Api.Migrations
{
    [DbContext(typeof(SchoolHeroContext))]
    [Migration("20190220002407_Initial")]
    partial class Initial
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "2.1.4-rtm-31024")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("School.Hero.Api.Models.Mission", b =>
                {
                    b.Property<int>("MissionId")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<DateTime>("DateCreation");

                    b.Property<string>("Description")
                        .IsRequired();

                    b.Property<int>("Experience");

                    b.Property<bool>("IsActive");

                    b.Property<bool>("IsCompleted");

                    b.Property<string>("Name")
                        .IsRequired();

                    b.Property<int>("Value");

                    b.HasKey("MissionId");

                    b.ToTable("Missions");

                    b.HasData(
                        new { MissionId = 1, DateCreation = new DateTime(2019, 2, 19, 21, 24, 7, 164, DateTimeKind.Local), Description = "Esta Missao é apenas de Teste", Experience = 100, IsActive = true, IsCompleted = false, Name = "Missao Teste 1", Value = 50 }
                    );
                });

            modelBuilder.Entity("School.Hero.Api.Models.Mission_User", b =>
                {
                    b.Property<int>("MissionUserId")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int>("MissionId");

                    b.Property<int>("UserId");

                    b.HasKey("MissionUserId");

                    b.HasIndex("MissionId");

                    b.HasIndex("UserId");

                    b.ToTable("Mission_Users");
                });

            modelBuilder.Entity("School.Hero.Api.Models.Permission", b =>
                {
                    b.Property<int>("PermissionId")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Description")
                        .IsRequired();

                    b.HasKey("PermissionId");

                    b.ToTable("Permissions");

                    b.HasData(
                        new { PermissionId = 1, Description = "Teacher" },
                        new { PermissionId = 2, Description = "Student" }
                    );
                });

            modelBuilder.Entity("School.Hero.Api.Models.Shop", b =>
                {
                    b.Property<int>("ShopId")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<DateTime>("DateCreation");

                    b.Property<string>("Description")
                        .IsRequired();

                    b.Property<bool>("IsActive");

                    b.Property<int>("Value");

                    b.HasKey("ShopId");

                    b.ToTable("Shops");
                });

            modelBuilder.Entity("School.Hero.Api.Models.User", b =>
                {
                    b.Property<int>("UserId")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int>("Coins");

                    b.Property<string>("FullName")
                        .IsRequired();

                    b.Property<bool>("IsActive");

                    b.Property<string>("Password")
                        .IsRequired();

                    b.Property<string>("Picture");

                    b.Property<string>("Username")
                        .IsRequired();

                    b.HasKey("UserId");

                    b.ToTable("Users");

                    b.HasData(
                        new { UserId = 1, Coins = 1000, FullName = "Marcos Cardoso de Oliveira Neto", IsActive = true, Password = "123456", Username = "Facal" },
                        new { UserId = 2, Coins = 1000, FullName = "Marcos Ducatti", IsActive = true, Password = "123456", Username = "Ducatti" }
                    );
                });

            modelBuilder.Entity("School.Hero.Api.Models.User_Permission", b =>
                {
                    b.Property<int>("UserPermissionId")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int>("PermissionId");

                    b.Property<int>("UserId");

                    b.HasKey("UserPermissionId");

                    b.HasIndex("PermissionId");

                    b.HasIndex("UserId");

                    b.ToTable("User_Permissions");

                    b.HasData(
                        new { UserPermissionId = 1, PermissionId = 1, UserId = 1 },
                        new { UserPermissionId = 2, PermissionId = 1, UserId = 2 }
                    );
                });

            modelBuilder.Entity("School.Hero.Api.Models.User_Shop", b =>
                {
                    b.Property<int>("UserShopId")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int>("ShopId");

                    b.Property<int>("UserId");

                    b.HasKey("UserShopId");

                    b.HasIndex("ShopId");

                    b.HasIndex("UserId");

                    b.ToTable("Users_Shop");
                });

            modelBuilder.Entity("School.Hero.Api.Models.Mission_User", b =>
                {
                    b.HasOne("School.Hero.Api.Models.Mission", "Mission")
                        .WithMany("MissionUsers")
                        .HasForeignKey("MissionId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("School.Hero.Api.Models.User", "User")
                        .WithMany("MissionUsers")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("School.Hero.Api.Models.User_Permission", b =>
                {
                    b.HasOne("School.Hero.Api.Models.Permission", "Permission")
                        .WithMany("UserPermissions")
                        .HasForeignKey("PermissionId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("School.Hero.Api.Models.User", "User")
                        .WithMany("UserPermissions")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("School.Hero.Api.Models.User_Shop", b =>
                {
                    b.HasOne("School.Hero.Api.Models.Shop", "Shop")
                        .WithMany("UsersShop")
                        .HasForeignKey("ShopId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("School.Hero.Api.Models.User", "User")
                        .WithMany("UsersShop")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade);
                });
#pragma warning restore 612, 618
        }
    }
}
